/*
 *	mtest.c
 *	Gerhard Pogrzeba, 1996
 */

#include <stdio.h>
#include <time.h>
#include "methan.h"

#define	ANZAHL		1000000L

int	main( void )
{
	stell_t	temp, druck, ventil;
	time_t	tstart, tend;
	long	n;

	METHANInit();
	time( &tstart );
	for( temp = 400.0, druck = 38.0; temp <= 1000.0 && druck <= 42.0;
	     temp += (1000.0-400.0)/ANZAHL, druck += (42.0-38.0)/ANZAHL )
		if( !METHANEvaluate( druck, temp, &ventil ) )
			return printf( "Bullshit at %lf, %lf\n", temp, druck ), -1;
	time( &tend );
	METHANTerminate();
	printf( "%lf ms per calculation\n", 1000.0 * (double) (tend - tstart) / (double) ANZAHL );
	return 0;
}